#!/bin/bash

WORK_DIR=$(cd $(dirname $0);pwd)
cd $WORK_DIR

Usage="Usage : update.sh -u ExecuteUser NoraDStarProxyGateway_vx.x.x.zip"

ExecuteUser="$SUDO_USER"

if [ ! "$USER" = "root" ]; then
    echo "Please execute sudo or root !" 1>&2
    exit 1
fi

while getopts u: OPT
do
  case $OPT in
    "u" ) ExecuteUser="$OPTARG" ;;
    * ) echo "$Usage" 1>&2
        exit 1 ;;
  esac
done

shift `expr $OPTIND - 1`

ArchiveFilePath="$1"

if [ ! -e "$ArchiveFilePath" ]; then
    echo "Could not found $ArchiveFilePath" 1>&2
    exit 1
fi


echo "NoraDStarProxyGateway SimpleUpdater"
echo ""
echo "User:$ExecuteUser"
echo ""

echo "[1] Backup config file..."
cp ./config/NoraDStarProxyGateway.xml ./config/NoraDStarProxyGateway.xml.backup

echo "[2] Backup hosts file..."
cp ./config/hosts.txt ./config/hosts.txt.backup

echo "[3] Remove NoraDStarProxyGateway application jar"
rm ./NoraDStarProxyGateway*.jar

echo "[4] Extract $1"
unzip -o $1 -d ../ >/dev/null 2>&1

echo "[5] Change Permission"
if [ ! -e ./NoraDStarProxyGateway.status ]; then
    touch ./NoraDStarProxyGateway.status
fi
chown -R $ExecuteUser:$ExecuteUser ../NoraDStarProxyGateway
chmod 755 ./log
chmod 644 ./log/*
chmod 644 ./NoraDStarProxyGateway.status
chmod 744 ./start.sh
chmod 744 ./update.sh
chmod 744 ./NoraDStarProxyGateway.bootstrap.sh
chmod 744 ./create_report.sh

if [ -e ./config/NoraDStarProxyGateway.xml ]; then
    echo "[6] Generate configuration diff to ./config/NoraDStarProxyGateway.xml.diff"
    diff ./config/NoraDStarProxyGateway.xml.default ./config/NoraDStarProxyGateway.xml > ./config/NoraDStarProxyGateway.xml.diff
fi

echo "Complete !"

exit 0
